Attribute VB_Name = "DlgModule"
Option Explicit

Type DlgReturnTypes
 MyFile     As String
 MyPath     As String
 MyFullPath As String
End Type

Private Type RECT
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type

Private Type POINTAPI
    X As Long
    Y As Long
End Type


'For Trapping Tab Key on Dialog Box
Public Declare Function CallNextHookEx Lib "user32" (ByVal hHook As Long, ByVal nCode As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Public Declare Function UnhookWindowsHookEx Lib "user32" (ByVal hHook As Long) As Long
Public Declare Function SetWindowsHookEx Lib "user32" Alias "SetWindowsHookExA" (ByVal idHook As Long, ByVal lpfn As Long, ByVal hmod As Long, ByVal dwThreadId As Long) As Long
Public Declare Function PostMessage Lib "user32" Alias "PostMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long


Public Const VK_TAB = &H9
Public Const VK_SHIFT = &H10
Public Const VK_CONTROL = &H11

Global hHook As Long

' General Constant
Public Const WM_USER = &H400
Public Const WM_MOVE = &H3
Public Const WM_SHOWWINDOW = &H18
Public Const WM_SETFOCUS = &H7
Public Const WM_KILLFOCUS = &H8
Public Const WM_LBUTTONDOWN = &H201
Public Const WM_LBUTTONUP = &H202
Public Const WH_KEYBOARD = 2

'Traps Alter Key
Public Const KBH_MASK = &H20000000

'Public Declare Function GetParent Lib "user32" (ByVal hwnd As Long) As Long
Public Declare Function SetParent Lib "user32" (ByVal hWndChild As Long, ByVal hWndNewParent As Long) As Long

Public Declare Function EnableWindow Lib "user32" (ByVal hwnd As Long, ByVal fEnable As Long) As Long
Public Declare Function SetWindowPos Lib "user32" (ByVal hwnd As Long, ByVal hWndInsertAfter As Long, ByVal X As Long, ByVal Y As Long, ByVal cx As Long, ByVal cy As Long, ByVal wFlags As Long) As Long
Public Declare Function GetKeyState Lib "user32" (ByVal nVirtKey As Long) As Integer
Public Declare Function GetFocus Lib "user32" () As Long
Public Declare Function SetFocus Lib "user32" (ByVal hwnd As Long) As Long
Public Declare Function GetDlgItem Lib "user32" (ByVal hDlg As Long, ByVal nIDDlgItem As Long) As Long
Public Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Integer, ByVal lParam As Any) As Long


'Returns Path file info
Public DlgFText As DlgReturnTypes


Public Const SWP_NOSIZE = &H1
Public Const SWP_NOMOVE = &H2
Public Const SWP_NOZORDER = &H4
Public Const SWP_NOREDRAW = &H8
Public Const SWP_NOACTIVATE = &H10
Public Const SWP_FRAMECHANGED = &H20        '//  The frame changed: send WM_NCCALCSIZE
Public Const SWP_SHOWWINDOW = &H40
Public Const SWP_HIDEWINDOW = &H80
Public Const SWP_NOCOPYBITS = &H100
Public Const SWP_NOOWNERZORDER = &H200      '//  Don't do owner Z ordering

Public Const SWP_DRAWFRAME = SWP_FRAMECHANGED
Public Const SWP_NOREPOSITION = SWP_NOOWNERZORDER


Public Const OFN_ALLOWMULTISELECT = &H200
Public Const OFN_CREATEPROMPT = &H2000
Public Const OFN_ENABLEHOOK = &H20
Public Const OFN_ENABLETEMPLATE = &H40
Public Const OFN_ENABLETEMPLATEHANDLE = &H80
Public Const OFN_EXPLORER = &H80000                         '//  new look commdlg
Public Const OFN_EXTENSIONDIFFERENT = &H400
Public Const OFN_FILEMUSTEXIST = &H1000
Public Const OFN_HIDEREADONLY = &H4
Public Const OFN_LONGNAMES = &H200000                       '//  force long names for 3.x modules
Public Const OFN_NOCHANGEDIR = &H8
Public Const OFN_NODEREFERENCELINKS = &H100000
Public Const OFN_NOLONGNAMES = &H40000                      '//   force no long names for 4.x modules
Public Const OFN_NONETWORKBUTTON = &H20000
Public Const OFN_NOREADONLYRETURN = &H8000
Public Const OFN_NOTESTFILECREATE = &H10000
Public Const OFN_NOVALIDATE = &H100
Public Const OFN_OVERWRITEPROMPT = &H2
Public Const OFN_PATHMUSTEXIST = &H800
Public Const OFN_READONLY = &H1
Public Const OFN_SHAREAWARE = &H4000
Public Const OFN_SHAREFALLTHROUGH = 2
Public Const OFN_SHARENOWARN = 1
Public Const OFN_SHAREWARN = 0
Public Const OFN_SHOWHELP = &H10
Public Const OFS_MAXPATHNAME = 128


'//   Commands to pass WinHelp()
 Public Const HELP_CONTEXT = &H1     '//  Display topic identified by number in Data
 Public Const HELP_QUIT = &H2        '//  Terminate help
 Public Const HELP_INDEX = &H3       '//  Display index
 Public Const HELP_HELPONHELP = &H4  '//  Display help on using help
 Public Const HELP_SETINDEX = &H5    '//  Set an alternate Index for help file with more than one index
 Public Const HELP_KEY = &H101       '//  Display topic for keyword in Data
 Public Const HELP_MULTIKEY = &H201  '//  Lookup keyword in alternate table and display topic


Public Declare Function SetDlgItemText& Lib "user32" Alias "SetDlgItemTextA" (ByVal hDlg As Long, ByVal nIDDlgItem As Long, ByVal lpString As String)
Public Declare Function GetDlgItemText& Lib "user32" Alias "GetDlgItemTextA" (ByVal hDlg As Long, ByVal nIDDlgItem As Long, ByVal lpString As String, ByVal nMaxCount As Long)
Public Declare Function SetDlgItemInt& Lib "user32" (ByVal hDlg As Long, ByVal nIDDlgItem As Long, ByVal wValue As Long, ByVal bSigned As Long)

'Public Declare Function GetWindowRect& Lib "user32" (ByVal hwnd As Long, lpRect As RECT)
'Public Declare Function ClientToScreen& Lib "user32" (ByVal hwnd As Long, lpPoint As POINTAPI)
'Public Declare Function ScreenToClient& Lib "user32" (ByVal hwnd As Long, lpPoint As POINTAPI)
'Public Declare Function GetClassName Lib "user32" Alias "GetClassNameA" (ByVal hwnd As Long, ByVal lpClassName As String, ByVal nMaxCount As Long) As Long

' Find Window Api Function - Used to Find ToolBar
'Public Declare Function FindWindowEx Lib "user32" Alias "FindWindowExA" _
                        (ByVal hWnd1 As Long, _
                        ByVal hWnd2 As Long, _
                        ByVal lpsz1 As String, _
                        ByVal lpsz2 As String) As Long
'Toolbar Const
'Public Const TBSTYLE_TRANSPARENT = &H8000
'Public Const TBSTYLE_FLAT = &H800
'Public Const TB_SETSTYLE = (WM_USER + 56)
'Public Const TB_GETSTYLE = (WM_USER + 57)
'Public Const CCS_NODIVIDER = &H40

Function CleanNull(TxtWithNull As String) As String
 
 If InStr(1, TxtWithNull, Chr(0)) > 0 Then
  CleanNull = Left(TxtWithNull, InStr(1, TxtWithNull, Chr(0)) - 1)
 Else
  CleanNull = TxtWithNull
 End If
 
End Function


Sub OpenCmDialog(FrmHwnd As Variant)
 
 Dim X As Long, Y As Long, W As Long, H As Long, i As Long
 Dim itmX        As ListItem

 
'For Testing and showing 'Recent' feature, where from and how Listview1's Data is up to you
 
 Set itmX = DlgForm.ListView1.ListItems.Add()
     'Put a real file and path to see if it works correctly
     itmX.Text = "Newimpro.Txt"
     itmX.SubItems(1) = App.Path + "\"
 Set itmX = DlgForm.ListView1.ListItems.Add()
     itmX.Text = "Filedlge.Txt"
     itmX.SubItems(1) = App.Path + "\"
 
    'All Controls are in Picture Control
    With DlgForm.Pic1Container
        X = .Left
        Y = .Top
        W = .Width
        H = .Height
        DlgForm.CmDlg.AddControl .hwnd, X, Y, H, W, DlgForm.hwnd
    End With
     
    'Change Default path if user has opened a file previously
    If DlgFText.MyPath <> "" Then
     DlgForm.CmDlg.InitDir = DlgFText.MyPath
    Else
     'Use Default
     DlgForm.CmDlg.InitDir = App.Path
    End If
    
    With DlgForm.CmDlg
        .ExtendedMode = True
        .FlatToolbar = False
        .HelpFile = "ccrpFileDialogs.hlp"
        '.Flags = ccrpOFN_SHOWHELP
        .Filter = "Text Files (*.Txt;*.Rtf)|*.Txt;*.Rtf|All Files (*.*)|*.*"
        .HelpCommand = fdlgHELP_CONTEXT
        .HelpContext = 15
        .hwndOwner = FrmHwnd
        .StartUpPosition = 2
        .ShowOpen      '// TRY CHANGING TO SHOWSAVE
    End With
    
    
    If DlgForm.CmDlg.DialogCanceled Then
     GoTo cleanup
    End If
         
    Dim totchar As Long
    Dim GFile As Variant        '// must be variant or object to support for...each
    For Each GFile In DlgForm.CmDlg.FileNames
       DlgFText.MyFile = GFile
       Exit For
    Next
    
   'Do if Recent File was picked
    If DlgForm.CmDlg.Tag <> "" Then
     DlgForm.CmDlg.Path = DlgForm.CmDlg.Tag
     DlgFText.MyFullPath = DlgForm.CmDlg.Path + DlgFText.MyFile
    Else
     DlgFText.MyFullPath = CleanNull(DlgForm.CmDlg.filename)
    End If
 
     DlgFText.MyPath = DlgForm.CmDlg.Path
     
cleanup:
     
    
    DlgForm.CmDlg.filename = ""
    DlgForm.CmDlg.Tag = ""
    SendMessage DlgForm.hwnd, WM_SETFOCUS, 0, 0&


End Sub

Function SetForwardFocus() As Long
  
    Dim CurHnd As Long
    Dim NewHnd As Long
    Dim Mx     As Long
    
    'Find Control handle with focus
    CurHnd = GetFocus()
    
       
       If CurHnd = DlgForm.TabStrip1.hwnd And DlgForm.TabStrip1.SelectedItem = "Existing" Then
        'Set Focus on FindIn Combo
        NewHnd = GetDlgItem(DlgForm.CmDlg.CommDlghWnd, fdlgCmbSaveInFindIn)
        SetFocus NewHnd
       
       ElseIf CurHnd = DlgForm.TabStrip1.hwnd And DlgForm.TabStrip1.SelectedItem = "Recent" Then
        'Set Focus on Recent Listview1
        NewHnd = DlgForm.ListView1.hwnd
        SetFocus NewHnd
       ElseIf CurHnd = GetDlgItem(DlgForm.CmDlg.CommDlghWnd, fdlgIDCANCEL) Then
        
        'Setfocus on Tabstrip
         
         NewHnd = True
         'Doing this was the only way I knew how to re-set focus on _
         Open Button then move focus to tabstrip... I'm sure there _
         has to be a better way.........
         
         'Set Mouse X,Y
         If DlgForm.TabStrip1.SelectedItem = "Recent" Then
          Mx = 131124
         Else
          Mx = 131074
         End If
         
         Call PostMessage(DlgForm.TabStrip1.hwnd, _
                                    WM_LBUTTONDOWN, _
                                    0, _
                                    Mx)
         Call PostMessage(DlgForm.TabStrip1.hwnd, _
                                    WM_LBUTTONUP, _
                                    0, _
                                    Mx)
                
       End If
                     
      
      
      
      If NewHnd <> 0 Then
       SetForwardFocus = 1
      Else
       SetForwardFocus = 0
      End If
     
   
    
End Function

Public Function KeyboardProc(ByVal nCode As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
         
'**CAUTION**  Make sure ALL new variables are declared if adding to this _
procedure else I guarentee you will lock up you computer...Keyboard _
functons may not work as expected without rebooting machine if you _
just shut Vb down with Ctl-Alt-Del _
--Parts-- of this KeyboardProc and a few more notes on it can be found at _
MS Knowledge Base:



         If nCode >= 0 Then         'Process keys you want to filter
            If wParam = 9 Then
               
               'First and second if are to make sure Alter or Control _
               key is not pressed
               
               If (lParam And &HC0000000) = 0 And (lParam And KBH_MASK) <> 0 Then
                'do nothing
               ElseIf GetKeyState(VK_CONTROL) = 0 Then
                  
                  If GetKeyState(VK_SHIFT) < 0 And GetKeyState(VK_TAB) < 0 Then
                   
                'My lack of know how, can be seen by use of lparam _
                 to make sure key is down but what the heck _
                 it works....SO FAR
                    
                                       
                   If lParam = 135200769 Or lParam = 1208942593 Then
                    
                    If SetBackwardFocus Then
                      KeyboardProc = 1
                      Exit Function
                     Else
                      'Do Nothing
                     End If
                     
                   End If
                  
                  ElseIf GetKeyState(VK_TAB) < 0 Then
                   
                   
                   
                   If lParam = 135200769 Or lParam = 1208942593 Then
                     
                     If SetForwardFocus Then
                      KeyboardProc = 1
                      Exit Function
                     Else
                      'Do Nothing
                     End If
                     
                   End If
                  
                  End If
                  
                  
               End If
            End If
         End If
         
         KeyboardProc = CallNextHookEx(hHook, nCode, wParam, lParam)
         
End Function


Function SetBackwardFocus() As Long
  
    Dim CurHnd As Long
    Dim NewHnd As Long
    
    'Find Control handle with focus
    CurHnd = GetFocus()
    
       
       If CurHnd = DlgForm.TabStrip1.hwnd Then
        'Set Focus on Cancel
        NewHnd = GetDlgItem(DlgForm.CmDlg.CommDlghWnd, fdlgIDCANCEL)
        SetFocus NewHnd
       ElseIf CurHnd = GetDlgItem(DlgForm.CmDlg.CommDlghWnd, fdlgCmbSaveInFindIn) And DlgForm.TabStrip1.SelectedItem = "Existing" Then
        'Set Focus on TabStrip
        NewHnd = DlgForm.TabStrip1.hwnd
        SetFocus NewHnd
       
       ElseIf CurHnd = DlgForm.ListView1.hwnd And DlgForm.TabStrip1.SelectedItem = "Recent" Then
        'Set Focus on TabStrip
        NewHnd = DlgForm.TabStrip1.hwnd
        SetFocus NewHnd
  
       ElseIf CurHnd = GetDlgItem(DlgForm.CmDlg.CommDlghWnd, fdlgIDOK) And DlgForm.TabStrip1.SelectedItem = "Recent" Then
        'Set Focus on Recent Listview1
        NewHnd = DlgForm.ListView1.hwnd
        SetFocus NewHnd
                 
       End If
                     
      
      
      
      If NewHnd <> 0 Then
       SetBackwardFocus = 1
      Else
       SetBackwardFocus = 0
      End If
     
   
    
End Function


